unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, NTime, ExtCtrls, Math, ShellAPI, MPlayer;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Panel1: TPanel;
    Panel2: TPanel;
    NTime1: TNTime;
    ISOPanel: TPanel;
    Button5: TButton;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Clock: TImage;
    Label8: TLabel;
    Edit8: TEdit;
    Label9: TLabel;
    Edit9: TEdit;
    AMPMPanel: TPanel;
    Label10: TLabel;
    Label11: TLabel;
    Edit10: TEdit;
    Edit11: TEdit;
    Label12: TLabel;
    GroupBox1: TGroupBox;
    Button6: TButton;
    NTime2: TNTime;
    Button7: TButton;
    Combo1: TComboBox;
    Label13: TLabel;
    Label14: TLabel;
    MediaPlayer1: TMediaPlayer;
    OpenDialog1: TOpenDialog;
    NTime3: TNTime;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    procedure NTime1Change(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure NTime1Alarm(Sender: TObject);
    procedure NTime1Tic(Sender: TObject);
    procedure Panel1Click(Sender: TObject);
    procedure Panel2Click(Sender: TObject);
    procedure NTime3Change(Sender: TObject);
    procedure NTime2Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.NTime1Change(Sender: TObject);
Var
   L      : Integer;
   Xo,Yo,X1,Y1      : Integer;
   a                : Extended;
begin
     {Properties}
     Edit1.Text:= IntToStr(NTime1.DaySeconds);
     Edit2.Text:= Format('%1.6f',[NTime1.asDegrees]);
     Edit3.Text:= Format('%1.6f',[NTime1.asRadians]);
     Edit4.Text:= Format('%1.6f',[NTime1.asDayFraction]);
     Edit5.Text:= Format('%1.6f',[RadToDeg(NTime1.HourAngle)]);
     Edit6.Text:= Format('%1.6f',[RadToDeg(NTime1.MinsAngle)]);
     Edit7.Text:= Format('%1.6f',[RadToDeg(NTime1.SecsAngle)]);
     Edit8.Text:= IntToStr(NTime1.HourAMPM);
     If NTime1.AMPM then Edit9.Text:= 'PM'
                    else Edit9.Text:= 'AM';

     Edit10.Text:= NTime1.ISOText;
     Edit11.Text:= NTime1.AMPMText;

     {Digital Clocks}
     ISOPanel.Caption:= NTime1.ISOText;
     AMPMPanel.Caption:= NTime1.AMPMText;

     {Analog Clock}
     {Clock can have any Bitmap as background}
     With Clock, Canvas do begin
          Ellipse(0,0,Width,Height);
          Xo:= Width div 2; Yo:= Height div 2;

          Pen.Width:= 3;
          L:= Width div 4;
          a:= NTime1.HourAngle;
          X1:= Xo+Round(L*sin(a)); Y1:= Yo-Round(L*cos(a));
          MoveTo(Xo,Yo);
          LineTo(X1,Y1);

          Pen.Width:= 2;
          L:= Round((Width div 2)*0.8);
          a:= NTime1.MinsAngle;
          X1:= Xo+Round(L*sin(a)); Y1:= Yo-Round(L*cos(a));
          MoveTo(Xo,Yo);
          LineTo(X1,Y1);

          Pen.Width:= 1;
          L:= Round((Width div 2)*0.9);
          a:= NTime1.SecsAngle;
          X1:= Xo+Round(L*sin(a)); Y1:= Yo-Round(L*cos(a));
          MoveTo(Xo,Yo);
          LineTo(X1,Y1);
          Ellipse(Round(Width *0.46),
                  Round(Height*0.46),
                  Round(Width *0.54),
                  Round(Height*0.54));
     end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
     NTime1.Visible:= False;
     NTime1.DaySeconds:= 0;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
     NTime1.Visible:= False;
     NTime1.Tic.Enabled:= False;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
     NTime1.Visible:= False;
     NTime1.DaySeconds:= Round(Frac(Time)*86400);
     NTime1.Tic.Enabled:= True;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
     NTime1.Visible:= False;
     NTime1.Tic.Enabled:= True;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
     NTime1.Tic.Enabled:= False;
     NTime1.Visible:= True;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
    Application.Title:= 'NazcaWeaver Time Editor Demo';
     With Clock, Canvas do begin
          Pen.Color:= clOlive;
          Pen.Width:= 1;
          Brush.Color:= clBtnFace;
          Ellipse(0,0,Width,Height);
     end;
     NTime1.DaySeconds:= Round(frac(Time)*86400);
     NTime3.DaySeconds:= NTime1.DaySeconds;
     Label16.Caption:= 'Time is '+NTime3.AMPMText;
     NTime1.Tic.Enabled:= True;
     NTime1.Alarm.Interval:= 30000;
     NTime1.Alarm.Enabled:= True;
     NTime2.DaySeconds:= 30;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
     NTime1.Alarm.Interval:= NTime2.DaySeconds*1000;
     NTime1.Alarm.Enabled:= True;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
     NTime1.Alarm.Enabled:= False;
     NTime1.Alarm.Interval:= 0;
end;

procedure TForm1.NTime1Alarm(Sender: TObject);
Var
   Ok: Boolean;
begin
     {Alarm}

     NTime1.Alarm.Enabled:= False;
     NTime1.Alarm.Interval:= 0;
     NTime2.DaySeconds:= 0;
     Case Combo1.ItemIndex Of
     0    : ShellExecute(Handle,'open',
            'http://members.directvinternet.com/nazcaweaver/',
            '','',SW_SHOW);
     1    : ShellExecute(Handle,'open',
            'mailto:nazcaweaver@directvinternet.com?Subject=Info Request','',
            '',SW_SHOW);
     2    : ShellExecute(Handle,'open','C:/','','',SW_SHOW);
     3    : begin
                 Ok:= False;
                 try
                 MediaPlayer1.Play;
                 except
                       On E: Exception do Ok:= MediaPlayer1.Error<>0;
                 end;
                 If not Ok then begin
                    If OpenDialog1.Execute then begin
                    MediaPlayer1.FileName:= OpenDialog1.FileName;
                    MediaPlayer1.AutoOpen:= True;
                    MediaPlayer1.Open;
                    MediaPlayer1.Play;
                    end;
                 end;
            end;
     end;
end;

procedure TForm1.NTime1Tic(Sender: TObject);
begin
     {It happens every 1000 milliseconds}
     If NTime1.Alarm.Enabled and (NTime2.DaySeconds>0) then
        NTime2.DaySeconds:= NTime2.DaySeconds-1;
end;

procedure TForm1.Panel1Click(Sender: TObject);
begin
     ShellExecute(Handle,'open',
     'http://members.directvinternet.com/nazcaweaver/',
     '','',SW_SHOW);
end;

procedure TForm1.Panel2Click(Sender: TObject);
begin
     ShellExecute(Handle,'open',
     'mailto:nazcaweaver@directvinternet.com?Subject=Info Request','',
     '',SW_SHOW);
end;

procedure TForm1.NTime3Change(Sender: TObject);
begin
     Label16.Caption:= 'Time is '+NTime3.AMPMText;
end;

procedure TForm1.NTime2Change(Sender: TObject);
begin
     Label18.Caption:= '*** '+NTime2.ISOText+' to take Action! ***';
end;

end.
